Index: trunk/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 5)
@@ -2572,183 +2420,6 @@
 #endif
 
-#if HHI_DMM_INTRA
-Void TEncSearch::xSearchWedgeFullMinDist( TComDataCU* pcCU, UInt uiAbsPtIdx, WedgeList* pacWedgeList, Pel* piRef, UInt uiRefStride, UInt uiWidth, UInt uiHeight, UInt& ruiTabIdx )
-{
-  ruiTabIdx = 0;
-
-  // local pred buffer
-  TComYuv cPredYuv;
-  cPredYuv.create( uiWidth, uiHeight );
-  cPredYuv.clear();
-
-  UInt uiPredStride = cPredYuv.getStride();
-  Pel* piPred       = cPredYuv.getLumaAddr();
-
-  Int  iDC1 = 0;
-  Int  iDC2 = 0;
-  // regular wedge search
-  Dist uiBestDist   = RDO_DIST_MAX;
-  UInt uiBestTabIdx = 0;
-
-  for( UInt uiIdx = 0; uiIdx < pacWedgeList->size(); uiIdx++ )
-  {
-    calcWedgeDCs       ( &(pacWedgeList->at(uiIdx)), piRef,  uiRefStride,  iDC1, iDC2 );
-    assignWedgeDCs2Pred( &(pacWedgeList->at(uiIdx)), piPred, uiPredStride, iDC1, iDC2 );
-
-    Dist uiActDist = RDO_DIST_MAX;
-    if( m_pcRdCost->getUseVSO() )
-    {
-      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
-    }
-    else
-    {
-      uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
-    }
-
-    if( uiActDist < uiBestDist || uiBestDist == RDO_DIST_MAX )
-    {
-      uiBestDist   = uiActDist;
-      uiBestTabIdx = uiIdx;
-    }
-  }
-  ruiTabIdx = uiBestTabIdx;
-
-  cPredYuv.destroy();
-  return;
-}
-
-Void TEncSearch::xSearchWedgePredDirMinDist( TComDataCU* pcCU, UInt uiAbsPtIdx, WedgeList* pacWedgeList, Pel* piRef, UInt uiRefStride, UInt uiWidth, UInt uiHeight, UInt& ruiTabIdx, Int& riWedgeDeltaEnd )
-{
-  ruiTabIdx       = 0;
-  riWedgeDeltaEnd = 0;
-
-  // local pred buffer
-  TComYuv cPredYuv;
-  cPredYuv.create( uiWidth, uiHeight );
-  cPredYuv.clear();
-
-  UInt uiPredStride = cPredYuv.getStride();
-  Pel* piPred       = cPredYuv.getLumaAddr();
-
-  Int  iDC1 = 0;
-  Int  iDC2 = 0;
-
-  // regular wedge search
-  Dist uiBestDist    = RDO_DIST_MAX;
-  UInt uiBestTabIdx  = 0;
-  Int  iBestDeltaEnd = 0;
-
-  UInt uiIdx = 0;
-  for( Int iTestDeltaEnd = -DMM_WEDGE_PREDDIR_DELTAEND_MAX; iTestDeltaEnd <= DMM_WEDGE_PREDDIR_DELTAEND_MAX; iTestDeltaEnd++ )
-  {
-    uiIdx = getBestContinueWedge( pcCU, uiAbsPtIdx, uiWidth, uiHeight, iTestDeltaEnd );
-    calcWedgeDCs       ( &(pacWedgeList->at(uiIdx)), piRef,  uiRefStride,  iDC1, iDC2 );
-    assignWedgeDCs2Pred( &(pacWedgeList->at(uiIdx)), piPred, uiPredStride, iDC1, iDC2 );
-
-    Dist uiActDist = RDO_DIST_MAX;
-    if( m_pcRdCost->getUseVSO() )
-    {
-      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
-    }
-    else
-    {
-      uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
-    }
-
-    if( uiActDist < uiBestDist || uiBestDist == RDO_DIST_MAX )
-    {
-      uiBestDist    = uiActDist;
-      uiBestTabIdx  = uiIdx;
-      iBestDeltaEnd = iTestDeltaEnd;
-    }
-    else if( uiIdx == uiBestTabIdx && abs(iTestDeltaEnd) < abs(iBestDeltaEnd) )
-    {
-      iBestDeltaEnd = iTestDeltaEnd;
-    }
-  }
-
-  ruiTabIdx       = uiBestTabIdx;
-  riWedgeDeltaEnd = iBestDeltaEnd;
-
-  cPredYuv.destroy();
-  return;
-}
-
-Bool TEncSearch::predIntraLumaDMMAvailable( UInt uiMode, Bool bAboveAvail, Bool bLeftAvail, UInt uiWidth, UInt uiHeight, TComDataCU* pcCU, UInt uiAbsPartIdx )
-{
-  if( uiMode <= MAX_MODE_ID_INTRA_DIR ) return true;
-
-  Bool bDMMAvailable = m_pcEncCfg->getUseDepthModelModes();
-
-  if( uiMode == DMM_WEDGE_FULL_IDX        ||
-      uiMode == DMM_WEDGE_FULL_D_IDX      ||
-      uiMode == DMM_WEDGE_PREDTEX_IDX     ||
-      uiMode == DMM_WEDGE_PREDTEX_D_IDX   ||
-      uiMode == DMM_CONTOUR_PREDTEX_IDX   ||
-      uiMode == DMM_CONTOUR_PREDTEX_D_IDX ||
-      uiMode == DMM_WEDGE_PREDDIR_IDX     ||
-      uiMode == DMM_WEDGE_PREDDIR_D_IDX     )
-  {
-    if( (uiWidth != uiHeight) || (uiWidth < DMM_WEDGEMODEL_MIN_SIZE) || (uiWidth > DMM_WEDGEMODEL_MAX_SIZE) )
-    {
-      bDMMAvailable = false;
-    }
-  }
-
-  return bDMMAvailable;
-}
-
+#if HHI_DMM_WEDGE_INTRA
 Void TEncSearch::findWedgeFullMinDist( TComDataCU*  pcCU,
-                                       UInt         uiAbsPtIdx,
-                                       Pel*         piOrig,
-                                       Pel*         piPredic,
-                                       UInt         uiStride,
-                                       UInt         uiWidth,
-                                       UInt         uiHeight,
-                                       UInt&        ruiTabIdx,
-                                       Int&         riDeltaDC1,
-                                       Int&         riDeltaDC2,
-                                       Bool         bAbove,
-                                       Bool         bLeft,
-                                       WedgeDist    eWedgeDist
-                                     )
-{
-  assert( uiWidth >= DMM_WEDGEMODEL_MIN_SIZE && uiWidth <= DMM_WEDGEMODEL_MAX_SIZE );
-
-  WedgeList* pacWedgeList = &g_aacWedgeLists[(g_aucConvertToBit[uiWidth])];
-  xSearchWedgeFullMinDist( pcCU, uiAbsPtIdx, pacWedgeList, piOrig, uiStride, uiWidth, uiHeight, ruiTabIdx );
-
-  TComWedgelet* pcBestWedgelet = &(pacWedgeList->at(ruiTabIdx));
-  xGetWedgeDeltaDCsMinDist( pcBestWedgelet, pcCU, uiAbsPtIdx, piOrig, piPredic, uiStride, uiWidth, uiHeight, riDeltaDC1, riDeltaDC2, bAbove, bLeft );
-}
-
-Void TEncSearch::findWedgePredDirMinDist( TComDataCU*  pcCU,
-                                          UInt         uiAbsPtIdx,
-                                          Pel*         piOrig,
-                                          Pel*         piPredic,
-                                          UInt         uiStride,
-                                          UInt         uiWidth,
-                                          UInt         uiHeight,
-                                          UInt&        ruiTabIdx,
-                                          Int&         riWedgeDeltaEnd,
-                                          Int&         riDeltaDC1,
-                                          Int&         riDeltaDC2,
-                                          Bool         bAbove,
-                                          Bool         bLeft,
-                                          WedgeDist    eWedgeDist )
-{
-  assert( uiWidth >= DMM_WEDGEMODEL_MIN_SIZE && uiWidth <= DMM_WEDGEMODEL_MAX_SIZE );
-  WedgeList* pacWedgeList = &g_aacWedgeLists[(g_aucConvertToBit[uiWidth])];
-
-  ruiTabIdx       = 0;
-  riWedgeDeltaEnd = 0;
-
-  xSearchWedgePredDirMinDist( pcCU, uiAbsPtIdx, pacWedgeList, piOrig, uiStride, uiWidth, uiHeight, ruiTabIdx, riWedgeDeltaEnd );
-
-  TComWedgelet* pcBestWedgelet = &(pacWedgeList->at(ruiTabIdx));
-  xGetWedgeDeltaDCsMinDist( pcBestWedgelet, pcCU, uiAbsPtIdx, piOrig, piPredic, uiStride, uiWidth, uiHeight, riDeltaDC1, riDeltaDC2, bAbove, bLeft );
-}
-
-Void TEncSearch::findWedgeTexMinDist( TComDataCU*  pcCU,
                                       UInt         uiAbsPtIdx,
                                       Pel*         piOrig,
@@ -2763,10 +2434,174 @@
                                       Bool         bLeft,
                                       WedgeDist    eWedgeDist
-                                    )
-  {
+                                      )
+{
+  assert( uiWidth >= DMM_WEDGEMODEL_MIN_SIZE && uiWidth <= DMM_WEDGEMODEL_MAX_SIZE );
+
+  WedgeList* pacWedgeList = &g_aacWedgeLists[(g_aucConvertToBit[uiWidth])];
+  xSearchWedgeFullMinDist( pcCU, uiAbsPtIdx, pacWedgeList, piOrig, uiStride, uiWidth, uiHeight, ruiTabIdx );
+
+  TComWedgelet* pcBestWedgelet = &(pacWedgeList->at(ruiTabIdx));
+  xGetWedgeDeltaDCsMinDist( pcBestWedgelet, pcCU, uiAbsPtIdx, piOrig, piPredic, uiStride, uiWidth, uiHeight, riDeltaDC1, riDeltaDC2, bAbove, bLeft );
+}
+
+Void TEncSearch::xSearchWedgeFullMinDist( TComDataCU* pcCU, UInt uiAbsPtIdx, WedgeList* pacWedgeList, Pel* piRef, UInt uiRefStride, UInt uiWidth, UInt uiHeight, UInt& ruiTabIdx )
+{
+  ruiTabIdx = 0;
+
+  // local pred buffer
+  TComYuv cPredYuv;
+  cPredYuv.create( uiWidth, uiHeight );
+  cPredYuv.clear();
+
+  UInt uiPredStride = cPredYuv.getStride();
+  Pel* piPred       = cPredYuv.getLumaAddr();
+
+  Int  iDC1 = 0;
+  Int  iDC2 = 0;
+  // regular wedge search
+  Dist uiBestDist   = RDO_DIST_MAX;
+  UInt uiBestTabIdx = 0;
+
+  for( UInt uiIdx = 0; uiIdx < pacWedgeList->size(); uiIdx++ )
+  {
+    calcWedgeDCs       ( &(pacWedgeList->at(uiIdx)), piRef,  uiRefStride,  iDC1, iDC2 );
+    assignWedgeDCs2Pred( &(pacWedgeList->at(uiIdx)), piPred, uiPredStride, iDC1, iDC2 );
+
+    Dist uiActDist = RDO_DIST_MAX;
+#if HHI_VSO
+    if( m_pcRdCost->getUseVSO() )
+    {
+      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+    }
+    else
+    {
+      uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
+    }
+#else
+    uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
+#endif
+
+    if( uiActDist < uiBestDist || uiBestDist == RDO_DIST_MAX )
+    {
+      uiBestDist   = uiActDist;
+      uiBestTabIdx = uiIdx;
+    }
+  }
+  ruiTabIdx = uiBestTabIdx;
+
+  cPredYuv.destroy();
+  return;
+}
+
+Void TEncSearch::findWedgePredDirMinDist( TComDataCU*  pcCU,
+                                         UInt         uiAbsPtIdx,
+                                         Pel*         piOrig,
+                                         Pel*         piPredic,
+                                         UInt         uiStride,
+                                         UInt         uiWidth,
+                                         UInt         uiHeight,
+                                         UInt&        ruiTabIdx,
+                                         Int&         riWedgeDeltaEnd,
+                                         Int&         riDeltaDC1,
+                                         Int&         riDeltaDC2,
+                                         Bool         bAbove,
+                                         Bool         bLeft,
+                                         WedgeDist    eWedgeDist )
+{
   assert( uiWidth >= DMM_WEDGEMODEL_MIN_SIZE && uiWidth <= DMM_WEDGEMODEL_MAX_SIZE );
   WedgeList* pacWedgeList = &g_aacWedgeLists[(g_aucConvertToBit[uiWidth])];
 
-  ruiTabIdx = getBestWedgeFromText( pcCU, uiAbsPtIdx, uiWidth, uiHeight );
+  ruiTabIdx       = 0;
+  riWedgeDeltaEnd = 0;
+
+  xSearchWedgePredDirMinDist( pcCU, uiAbsPtIdx, pacWedgeList, piOrig, uiStride, uiWidth, uiHeight, ruiTabIdx, riWedgeDeltaEnd );
+
+  TComWedgelet* pcBestWedgelet = &(pacWedgeList->at(ruiTabIdx));
+  xGetWedgeDeltaDCsMinDist( pcBestWedgelet, pcCU, uiAbsPtIdx, piOrig, piPredic, uiStride, uiWidth, uiHeight, riDeltaDC1, riDeltaDC2, bAbove, bLeft );
+}
+
+Void TEncSearch::xSearchWedgePredDirMinDist( TComDataCU* pcCU, UInt uiAbsPtIdx, WedgeList* pacWedgeList, Pel* piRef, UInt uiRefStride, UInt uiWidth, UInt uiHeight, UInt& ruiTabIdx, Int& riWedgeDeltaEnd )
+{
+  ruiTabIdx       = 0;
+  riWedgeDeltaEnd = 0;
+
+  // local pred buffer
+  TComYuv cPredYuv;
+  cPredYuv.create( uiWidth, uiHeight );
+  cPredYuv.clear();
+
+  UInt uiPredStride = cPredYuv.getStride();
+  Pel* piPred       = cPredYuv.getLumaAddr();
+
+  Int  iDC1 = 0;
+  Int  iDC2 = 0;
+
+  // regular wedge search
+  Dist uiBestDist    = RDO_DIST_MAX;
+  UInt uiBestTabIdx  = 0;
+  Int  iBestDeltaEnd = 0;
+
+  UInt uiIdx = 0;
+  for( Int iTestDeltaEnd = -DMM_WEDGE_PREDDIR_DELTAEND_MAX; iTestDeltaEnd <= DMM_WEDGE_PREDDIR_DELTAEND_MAX; iTestDeltaEnd++ )
+  {
+    uiIdx = getBestContinueWedge( pcCU, uiAbsPtIdx, uiWidth, uiHeight, iTestDeltaEnd );
+    calcWedgeDCs       ( &(pacWedgeList->at(uiIdx)), piRef,  uiRefStride,  iDC1, iDC2 );
+    assignWedgeDCs2Pred( &(pacWedgeList->at(uiIdx)), piPred, uiPredStride, iDC1, iDC2 );
+
+    Dist uiActDist = RDO_DIST_MAX;
+#if HHI_VSO
+    if( m_pcRdCost->getUseVSO() )
+    {
+      uiActDist = m_pcRdCost->getDistVS( pcCU, 0, piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, false, 0 );
+    }
+    else
+    {
+      uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
+    }
+#else
+    uiActDist = m_pcRdCost->getDistPart( piPred, uiPredStride, piRef, uiRefStride, uiWidth, uiHeight, DF_SAD );
+#endif
+
+    if( uiActDist < uiBestDist || uiBestDist == RDO_DIST_MAX )
+    {
+      uiBestDist    = uiActDist;
+      uiBestTabIdx  = uiIdx;
+      iBestDeltaEnd = iTestDeltaEnd;
+    }
+    else if( uiIdx == uiBestTabIdx && abs(iTestDeltaEnd) < abs(iBestDeltaEnd) )
+    {
+      iBestDeltaEnd = iTestDeltaEnd;
+    }
+  }
+
+  ruiTabIdx       = uiBestTabIdx;
+  riWedgeDeltaEnd = iBestDeltaEnd;
+
+  cPredYuv.destroy();
+  return;
+}
+#endif
+
+#if HHI_DMM_PRED_TEX
+Void TEncSearch::findWedgeTexMinDist( TComDataCU*  pcCU, 
+                                      UInt         uiAbsPtIdx, 
+                                      Pel*         piOrig, 
+                                      Pel*         piPredic, 
+                                      UInt         uiStride, 
+                                      UInt         uiWidth, 
+                                      UInt         uiHeight, 
+                                      UInt&        ruiTabIdx, 
+                                      Int&         riDeltaDC1, 
+                                      Int&         riDeltaDC2, 
+                                      Bool         bAbove, 
+                                      Bool         bLeft, 
+                                      WedgeDist    eWedgeDist,
+                                      Pel*         piTextureRef
+                                    )
+  {
+  assert( uiWidth >= DMM_WEDGEMODEL_MIN_SIZE && uiWidth <= DMM_WEDGEMODEL_MAX_SIZE );
+  WedgeList* pacWedgeList = &g_aacWedgeLists[(g_aucConvertToBit[uiWidth])];
+
+  ruiTabIdx = getBestWedgeFromText( pcCU, uiAbsPtIdx, uiWidth, uiHeight, eWedgeDist, piTextureRef );
 
   TComWedgelet* pcBestWedgelet = &(pacWedgeList->at(ruiTabIdx));
@@ -2784,9 +2619,10 @@
                                      Int&         riDeltaDC2,
                                      Bool         bAbove,
-                                     Bool         bLeft )
+                                     Bool         bLeft,
+                                     Pel*         piTextureRef )
 {
   // get contour pattern
   TComWedgelet* pcContourWedge = new TComWedgelet( uiWidth, uiHeight );
-  getBestContourFromText( pcCU, uiAbsPtIdx, uiWidth, uiHeight, pcContourWedge );
+  getBestContourFromText( pcCU, uiAbsPtIdx, uiWidth, uiHeight, pcContourWedge, piTextureRef );
 
   xGetWedgeDeltaDCsMinDist( pcContourWedge, pcCU, uiAbsPtIdx, piOrig, piPredic, uiStride, uiWidth, uiHeight, riDeltaDC1, riDeltaDC2, bAbove, bLeft );
@@ -2795,5 +2631,6 @@
   delete pcContourWedge;
 }
-
+#endif
+#if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
 Void TEncSearch::xGetWedgeDeltaDCsMinDist( TComWedgelet* pcWedgelet,
                                            TComDataCU*   pcCU,
@@ -2824,4 +2661,5 @@
   riDeltaDC2 = iDC2 - iPredDC2;
 
+#if HHI_VSO
   if( m_pcRdCost->getUseVSO() )
   {
@@ -2875,7 +2713,43 @@
     riDeltaDC2 = iFullDeltaDC2;
   }
+#endif
 
   xDeltaDCQuantScaleDown( pcCU, riDeltaDC1 );
   xDeltaDCQuantScaleDown( pcCU, riDeltaDC2 );
+}
+
+Bool TEncSearch::predIntraLumaDMMAvailable( UInt uiMode, UInt uiWidth, UInt uiHeight )
+{
+  if( uiMode <= MAX_MODE_ID_INTRA_DIR ) return true;
+
+  Bool bDMMAvailable = m_pcEncCfg->getUseDMM();
+
+#if HHI_DMM_WEDGE_INTRA
+  if( uiMode == DMM_WEDGE_FULL_IDX        ||
+      uiMode == DMM_WEDGE_FULL_D_IDX      ||
+      uiMode == DMM_WEDGE_PREDDIR_IDX     ||
+      uiMode == DMM_WEDGE_PREDDIR_D_IDX )
+  {
+    if( (uiWidth != uiHeight) || (uiWidth < DMM_WEDGEMODEL_MIN_SIZE) || (uiWidth > DMM_WEDGEMODEL_MAX_SIZE) || ( ( uiMode == DMM_WEDGE_PREDDIR_IDX || uiMode == DMM_WEDGE_PREDDIR_D_IDX ) && uiWidth == 4 ) )
+    {
+      bDMMAvailable = false;
+    }
+  }
+#endif
+#if HHI_DMM_PRED_TEX
+  if( uiMode == DMM_WEDGE_PREDTEX_IDX     ||
+      uiMode == DMM_WEDGE_PREDTEX_D_IDX   ||
+      uiMode == DMM_CONTOUR_PREDTEX_IDX   ||
+      uiMode == DMM_CONTOUR_PREDTEX_D_IDX )
+  {
+    if( (uiWidth != uiHeight) || (uiWidth < DMM_WEDGEMODEL_MIN_SIZE) || (uiWidth > DMM_WEDGEMODEL_MAX_SIZE) || ( ( uiMode == DMM_CONTOUR_PREDTEX_IDX || uiMode == DMM_CONTOUR_PREDTEX_D_IDX ) && uiWidth == 4 ) )
+    {
+      bDMMAvailable = false;
+    }
+  }
+
+#endif
+
+  return bDMMAvailable;
 }
 
@@ -4033,21 +3907,16 @@
   uiCost = ruiDist + m_pcRdCost->getCost( m_auiMVPIdxCost[iMVPIdx][iMVPNum] );
 #else
-//GT VSO
+#if HHI_VSO
   if ( false /*m_pcRdCost->getUseVSO()*/ ) // GT: currently disabled
   {
-  #if GERHARD_VQM_XCHECK
-    UInt uiCost1 = m_pcRdCost->getDistVS  ( pcCU, uiPartAddr,  pcTemplateCand->getLumaAddr(uiPartAddr), pcTemplateCand->getStride(), pcOrgYuv->getLumaAddr(uiPartAddr), pcOrgYuv->getStride(), iSizeX, iSizeY, true, 0);
-    UInt uiCost2 = m_pcRdCost->getDistPart( pcTemplateCand->getLumaAddr(uiPartAddr), pcTemplateCand->getStride(), pcOrgYuv->getLumaAddr(uiPartAddr), pcOrgYuv->getStride(), iSizeX, iSizeY, DF_SAD );
-    assert(uiCost1 == uiCost2);
-  #endif
     uiCost = m_pcRdCost->getDistVS  ( pcCU, uiPartAddr,  pcTemplateCand->getLumaAddr(uiPartAddr), pcTemplateCand->getStride(), pcOrgYuv->getLumaAddr(uiPartAddr), pcOrgYuv->getStride(), iSizeX, iSizeY, true, 0);
     uiCost = (UInt) m_pcRdCost->calcRdCostVSO( m_auiMVPIdxCost[iMVPIdx][iMVPNum], uiCost, false, DF_SAD );
   }
   else
+#endif
   {
     uiCost = m_pcRdCost->getDistPart( pcTemplateCand->getLumaAddr(uiPartAddr), pcTemplateCand->getStride(), pcOrgYuv->getLumaAddr(uiPartAddr), pcOrgYuv->getStride(), iSizeX, iSizeY, DF_SAD );
     uiCost = (UInt) m_pcRdCost->calcRdCost( m_auiMVPIdxCost[iMVPIdx][iMVPNum], uiCost, false, DF_SAD );
   }
-//GT VSO end
 #endif
   return uiCost;
@@ -4123,5 +3992,5 @@
 
   m_pcRdCost->setPredictor  ( *pcMvPred );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( pcCU->getSlice()->getSPS()->isDepth() )
     m_pcRdCost->setCostScale  ( 0 );
@@ -4130,8 +3999,9 @@
   m_pcRdCost->setCostScale  ( 2 );
 
+#if HHI_INTER_VIEW_MOTION_PRED
   { // init inter-view regularization
     TComMv  cOrgDepthMapMv;
     Bool    bMultiviewReg = pcCU->getIViewOrgDepthMvPred( iPartIdx, eRefPicList, iRefIdxPred, cOrgDepthMapMv );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
     if( bMultiviewReg && pcCU->getSlice()->getSPS()->isDepth() )
     {
@@ -4146,4 +4016,5 @@
     }
   }
+#endif
 
   //  Do integer search
@@ -4179,5 +4050,5 @@
 
   m_pcRdCost->getMotionCost( 1, 0 );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( ! pcCU->getSlice()->getSPS()->isDepth() )
   {
@@ -4203,10 +4074,10 @@
   rcMv += (cMvHalf <<= 1);
   rcMv +=  cMvQter;
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   }
 #endif
 
   UInt uiMvBits = m_pcRdCost->getBits( rcMv.getHor(), rcMv.getVer() );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( pcCU->getSlice()->getSPS()->isDepth() )
     ruiCost += m_pcRdCost->getCost( uiMvBits );
@@ -4221,5 +4092,5 @@
 {
   Int  iMvShift = 2;
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( pcCU->getSlice()->getSPS()->isDepth() )
     iMvShift = 0;
@@ -4394,5 +4265,5 @@
   UInt uiSearchRange = m_iSearchRange;
   pcCU->clipMv( rcMv );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
   if( ! pcCU->getSlice()->getSPS()->isDepth() )
 #endif
@@ -4414,5 +4285,5 @@
       TComMv cMv = m_acMvPredictors[index];
       pcCU->clipMv( cMv );
-#if MW_DEPTH_MAP_INTERP_FILTER == 2 && MW_FULL_PEL_DEPTH_MAP_MV_SIGNALLING
+#if HHI_FULL_PEL_DEPTH_MAP_MV_ACC
       if( ! pcCU->getSlice()->getSPS()->isDepth() )
 #endif
@@ -4726,4 +4597,5 @@
     pcYuvPred->copyToPartYuv( rpcYuvRec, 0 );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     // add residual prediction
     if( pcCU->getResPredFlag( 0 ) )
@@ -4732,16 +4604,13 @@
       rpcYuvRec->clip( uiWidth, uiHeight );
     }
-
-    //GT VSO
+#endif
+
+#if HHI_VSO    
     if ( m_pcRdCost->getUseVSO() )
     {
-  #if GERHARD_VQM_XCHECK
-      UInt uiDistortion1 = m_pcRdCost->getDistPart( rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight );
-      UInt uiDistortion2 = m_pcRdCost->getDistVS( pcCU, 0, rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight     , false, 0 );
-      assert( uiDistortion1 == uiDistortion2 );
-  #endif
       uiDistortion = m_pcRdCost->getDistVS( pcCU, 0, rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight     , false, 0 );
     }
     else
+#endif
     {
       uiDistortion = m_pcRdCost->getDistPart( rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight      )
@@ -4749,5 +4618,5 @@
       + m_pcRdCost->getDistPart( rpcYuvRec->getCrAddr(),   rpcYuvRec->getCStride(), pcYuvOrg->getCrAddr(),   pcYuvOrg->getCStride(), uiWidth >> 1, uiHeight >> 1 );
     }
-    //GT VSO end
+    
 
     if( m_bUseSBACRD )
@@ -4755,5 +4624,5 @@
 
     m_pcEntropyCoder->resetBits();
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
     if( pcCU->getTextureModeDepth( 0 ) == -1 )
     {
@@ -4772,6 +4641,8 @@
     }
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     m_pcEntropyCoder->encodeResPredFlag( pcCU, 0, 0, true );
-#if MW_MVI_SIGNALLING_MODE == 1
+#endif
+#if HHI_MPI
     }
 #endif
@@ -4780,5 +4651,6 @@
     pcCU->getTotalBits()       = uiBits;
     pcCU->getTotalDistortion() = uiDistortion;
-    //GT VSO
+
+#if HHI_VSO
     if ( m_pcRdCost->getUseLambdaScaleVSO() )
     {
@@ -4786,8 +4658,8 @@
     }
     else
+#endif
     {
       pcCU->getTotalCost() = m_pcRdCost->calcRdCost( uiBits, uiDistortion );
     }
-    //GT VSO end
 
     if( m_bUseSBACRD )
@@ -4797,4 +4669,5 @@
     pcCU->setTrIdxSubParts( 0, 0, pcCU->getDepth(0) );
 
+#if HHI_VSO
     // set Model
     if( m_pcRdCost->getUseRenModel() )
@@ -4804,4 +4677,5 @@
       m_pcRdCost->setRenModelData( pcCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
     }
+#endif
 
     return;
@@ -4828,4 +4702,5 @@
   pcYuvPred->copyToPartYuv( rpcYuvRec, 0 );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   // add residual prediction
   if( pcCU->getResPredFlag( 0 ) )
@@ -4833,5 +4708,6 @@
     rpcYuvRec->add( rpcYuvResPrd, uiWidth, uiHeight );
   }
-  #if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
   if( bSkipRes)
   {
@@ -4858,19 +4734,23 @@
 
     Dist uiZeroDistortion = 0;
-//GT VSO
+#if HHI_VSO
     if ( m_pcRdCost->getUseVSO() )
     {
       m_cYuvRecTemp.create( pcYuvPred->getWidth(), pcYuvPred->getHeight()  );
     }
+#endif
 
     xEstimateResidualQT( pcCU, 0, 0, pcYuvOrg, rpcYuvRec, rpcYuvResi,  pcCU->getDepth(0), dCost, uiBits, uiDistortion, &uiZeroDistortion );
 
+#if HHI_VSO
     if ( m_pcRdCost->getUseVSO() )
     {
       m_cYuvRecTemp.destroy();
     }
-//GT VSO end
+#endif
+
 
     double dZeroCost;
+#if HHI_VSO
     if( m_pcRdCost->getUseLambdaScaleVSO() )
     {
@@ -4878,4 +4758,5 @@
     }
     else
+#endif
     {
       dZeroCost = m_pcRdCost->calcRdCost( 0, uiZeroDistortion );
@@ -4926,4 +4807,5 @@
 
     Double dExactCost;
+#if HHI_VSO
     if( m_pcRdCost->getUseLambdaScaleVSO() )
     {
@@ -4931,4 +4813,5 @@
     }
     else
+#endif
     {
       dExactCost = m_pcRdCost->calcRdCost( uiBits, uiDistortion );
@@ -4970,4 +4853,5 @@
     }
 
+#if HHI_VSO
     // reset Model
     if( m_pcRdCost->getUseRenModel() )
@@ -4977,4 +4861,5 @@
       m_pcRdCost->setRenModelData( pcCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
     }
+#endif
   }
 
@@ -5002,15 +4887,11 @@
   // update with clipped distortion and cost (qp estimation loop uses unclipped values)
 
-  //GT VSO
+#if HHI_VSO
   if ( m_pcRdCost->getUseVSO() )
   {
-  #if GERHARD_VQM_XCHECK
-    UInt uiDistortionBest1 = m_pcRdCost->getDistVS  ( pcCU, 0, rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight, false, 0    );
-    UInt uiDistortionBest2 = m_pcRdCost->getDistPart( rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight      );
-    assert( uiDistortionBest1 == uiDistortionBest2 );
-  #endif
     uiDistortionBest = m_pcRdCost->getDistVS  ( pcCU, 0, rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight, false, 0    );
   }
   else
+#endif
   {
     uiDistortionBest = m_pcRdCost->getDistPart( rpcYuvRec->getLumaAddr(), rpcYuvRec->getStride(),  pcYuvOrg->getLumaAddr(), pcYuvOrg->getStride(),  uiWidth,      uiHeight      )
@@ -5018,7 +4899,6 @@
     + m_pcRdCost->getDistPart( rpcYuvRec->getCrAddr(),   rpcYuvRec->getCStride(), pcYuvOrg->getCrAddr(),   pcYuvOrg->getCStride(), uiWidth >> 1, uiHeight >> 1 );
   }
-//GT VSO end
-
-//GT VSO
+
+#if HHI_VSO
   if ( m_pcRdCost->getUseLambdaScaleVSO() )
   {
@@ -5026,8 +4906,8 @@
   }
   else
+#endif
   {
     dCostBest = m_pcRdCost->calcRdCost( uiBitsBest, uiDistortionBest );
   }
-//GT VSO end
 
   pcCU->getTotalBits()       = uiBitsBest;
@@ -5044,4 +4924,5 @@
 
   // set Model
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -5050,4 +4931,5 @@
     m_pcRdCost->setRenModelData( pcCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 }
 
@@ -5167,15 +5049,11 @@
     ::memset( m_pTempPel, 0, sizeof( Pel ) * uiNumSamplesLuma ); // not necessary needed for inside of recursion (only at the beginning)
 
+#if HHI_VSO
     if ( m_pcRdCost->getUseVSO() )
     {
       uiDistY = m_pcRdCost->getDistVS  ( pcCU, uiAbsPartIdx, pcPred->getLumaAddr( uiAbsPartIdx ), pcPred->getStride(), pcOrg->getLumaAddr( uiAbsPartIdx), pcOrg->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize, false, 0 ); // initialized with zero residual distortion
-
-  #if GERHARD_VQM_XCHECK
-      UInt uiDist1 = m_pcRdCost->getDistPart( pcOrg->getLumaAddr( uiAbsPartIdx), pcOrg->getStride(), pcPred->getLumaAddr( uiAbsPartIdx ), pcPred->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize ); // initialized with zero residual distortion
-      UInt uiDist2  = m_pcRdCost->getDistPart( m_pTempPel, 1<< uiLog2TrSize, pcResi->getLumaAddr( uiAbsPartIdx ), pcResi->getStride(), 1<< uiLog2TrSize, 1<< uiLog2TrSize ); // initialized with zero residual distortion
-      assert( uiDist1 == uiDist2 );
-  #endif
     }
     else
+#endif
     {
 #if IBDI_DISTORTION
@@ -5185,5 +5063,5 @@
 #endif
     }
-//GT VSO end
+
 
     if ( puiZeroDist )
@@ -5203,5 +5081,5 @@
       Dist uiNonzeroDistY;
 
-      //GT VSO
+#if HHI_VSO      
       if ( m_pcRdCost->getUseVSO() )
       {
@@ -5209,25 +5087,16 @@
         uiNonzeroDistY = m_pcRdCost->getDistVS( pcCU, uiAbsPartIdx, m_cYuvRecTemp.getLumaAddr(uiAbsPartIdx), m_cYuvRecTemp.getStride(),
                                                 pcOrg->getLumaAddr( uiAbsPartIdx ), pcOrg->getStride(), 1<< uiLog2TrSize,   1<< uiLog2TrSize, false, 0 );
-
-  #if GERHARD_VQM_XCHECK
-        UInt uiDist1 = m_pcRdCost->getDistPart( m_cYuvRecTemp.getLumaAddr(uiAbsPartIdx), m_cYuvRecTemp.getStride(),
-                                                pcOrg->getLumaAddr( uiAbsPartIdx ), pcOrg->getStride(), 1<< uiLog2TrSize,    1<< uiLog2TrSize );
-
-        UInt uiDist2 = m_pcRdCost->getDistPart( m_pcQTTempTComYuv[uiQTTempAccessLayer].getLumaAddr( uiAbsPartIdx ), m_pcQTTempTComYuv[uiQTTempAccessLayer].getStride(),
-                                                pcResi->getLumaAddr( uiAbsPartIdx ), pcResi->getStride(), 1<< uiLog2TrSize,    1<< uiLog2TrSize );
-        assert( uiDist1 == uiDist2);
-  #endif
       }
       else
+#endif
       {
         uiNonzeroDistY = m_pcRdCost->getDistPart( m_pcQTTempTComYuv[uiQTTempAccessLayer].getLumaAddr( uiAbsPartIdx ), m_pcQTTempTComYuv[uiQTTempAccessLayer].getStride(),
                                                   pcResi->getLumaAddr( uiAbsPartIdx ), pcResi->getStride(), 1<< uiLog2TrSize,    1<< uiLog2TrSize );
       }
-      //GT VSO end
 
       Double dSingleCostY;
       Double dNullCostY;
 
-      //GT VSO
+#if HHI_VSO      
       if ( m_pcRdCost->getUseLambdaScaleVSO())
       {
@@ -5236,9 +5105,9 @@
       }
       else
+#endif
       {
         dSingleCostY = m_pcRdCost->calcRdCost( uiSingleBitsY, uiNonzeroDistY );
         dNullCostY   = m_pcRdCost->calcRdCost( 0, uiDistY );
       }
-      //GT VSO end
 
 
@@ -5406,5 +5275,5 @@
 
     uiSingleDist = uiDistY + uiDistU + uiDistV;
-//GT VSO
+#if HHI_VSO
     if ( m_pcRdCost->getUseLambdaScaleVSO())
     {
@@ -5412,8 +5281,8 @@
     }
     else
+#endif
     {
       dSingleCost = m_pcRdCost->calcRdCost( uiSingleBits, uiSingleDist );
     }
-//GT VSO end
   }
 
@@ -5467,5 +5336,5 @@
     uiSubdivBits = m_pcEntropyCoder->getNumberOfWrittenBits();
 
-//GT VSO
+#if HHI_VSO
     if ( m_pcRdCost->getUseLambdaScaleVSO())
     {
@@ -5473,8 +5342,8 @@
     }
     else
+#endif
     {
       dSubdivCost  = m_pcRdCost->calcRdCost( uiSubdivBits, uiSubdivDist );
     }
-//GT VSO end
 
     if( uiYCbf || uiUCbf || uiVCbf || !bCheckFull )
@@ -5495,4 +5364,5 @@
   }
 
+#if HHI_VSO
   if ( m_pcRdCost->getUseRenModel() )
   {
@@ -5515,6 +5385,8 @@
       uiSrcStride = pcPred->getStride  ();
     }
+
     m_pcRdCost->setRenModelData( pcCU, uiAbsPartIdx, piSrc, (Int) uiSrcStride, (Int) uiWidth, (Int) uiHeight );
   }
+#endif
 
   rdCost += dSingleCost;
@@ -5762,7 +5634,5 @@
   if ( pcCU->isSkipped( 0 ) )
   {
-#if MW_MVI_SIGNALLING_MODE == 0
-    assert( pcCU->getTextureModeDepth( 0 ) == -1 );
-#elif MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
     if( pcCU->getTextureModeDepth( 0 ) != -1 )
     {
@@ -5787,5 +5657,7 @@
     }
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     m_pcEntropyCoder->encodeResPredFlag( pcCU, 0, 0, true );
+#endif
     ruiBits += m_pcEntropyCoder->getNumberOfWrittenBits();
   }
@@ -5793,18 +5665,14 @@
   {
     m_pcEntropyCoder->resetBits();
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
     if( pcCU->getTextureModeDepth( 0 ) == -1 )
     {
 #endif
-    m_pcEntropyCoder->encodeSkipFlag ( pcCU, 0, true );
+      m_pcEntropyCoder->encodeSkipFlag ( pcCU, 0, true );
 #if HHI_MRG_SKIP
-    if (pcCU->getPredictionMode(0) == MODE_SKIP)
-    {
-      pcCU->setPredModeSubParts( MODE_INTER, 0, pcCU->getDepth(0) );
-    }
-#endif
-#if MW_MVI_SIGNALLING_MODE == 0
-    if( pcCU->getTextureModeDepth( 0 ) == -1 )
-    {
+      if (pcCU->getPredictionMode(0) == MODE_SKIP)
+      {
+        pcCU->setPredModeSubParts( MODE_INTER, 0, pcCU->getDepth(0) );
+      }
 #endif
       m_pcEntropyCoder->encodePredMode( pcCU, 0, true );
@@ -5812,6 +5680,10 @@
       m_pcEntropyCoder->encodePredInfo( pcCU, 0, true );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       m_pcEntropyCoder->encodeResPredFlag( pcCU, 0, 0, true );
-    }
+#endif
+#if HHI_MPI
+    }
+#endif
     m_pcEntropyCoder->encodeCoeff   ( pcCU, 0, pcCU->getDepth(0), pcCU->getWidth(0), pcCU->getHeight(0) );
 
